'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var PropTypes = _interopRequireWildcard(_propTypes);

var _relayRuntime = require('relay-runtime');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _createEnvironment = require('./relay/createEnvironment');

var _createEnvironment2 = _interopRequireDefault(_createEnvironment);

var _Config = require('./Config');

var _Config2 = _interopRequireDefault(_Config);

var _store = require('./store');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ReleasyProvider = function (_React$PureComponent) {
  (0, _inherits3.default)(ReleasyProvider, _React$PureComponent);

  function ReleasyProvider(props) {
    (0, _classCallCheck3.default)(this, ReleasyProvider);

    (0, _invariant2.default)(props.config, 'ReleasyProvider: missing "config"');
    (0, _invariant2.default)(props.children, 'ReleasyProvider: missing "children"');

    var _this = (0, _possibleConstructorReturn3.default)(this, (ReleasyProvider.__proto__ || (0, _getPrototypeOf2.default)(ReleasyProvider)).call(this, props));

    (0, _store.setEnvironment)((0, _createEnvironment2.default)(props.config));
    return _this;
  }

  (0, _createClass3.default)(ReleasyProvider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return {
        environment: (0, _store.getEnvironment)()
      };
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children;
    }
  }]);
  return ReleasyProvider;
}(React.PureComponent);

ReleasyProvider.propTypes = {
  config: PropTypes.instanceOf(_Config2.default).isRequired,
  children: PropTypes.element.isRequired
};
ReleasyProvider.childContextTypes = {
  environment: PropTypes.instanceOf(_relayRuntime.Environment).isRequired
};
exports.default = ReleasyProvider;