'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var PropTypes = _interopRequireWildcard(_propTypes);

var _reactRelay = require('react-relay');

var _relayRuntime = require('relay-runtime');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var query = function query(queryParam, variablesParam) {
  return function (WrappedComponent) {
    // eslint-disable-next-line
    var Query = function (_React$PureComponent) {
      (0, _inherits3.default)(Query, _React$PureComponent);

      function Query() {
        (0, _classCallCheck3.default)(this, Query);
        return (0, _possibleConstructorReturn3.default)(this, (Query.__proto__ || (0, _getPrototypeOf2.default)(Query)).apply(this, arguments));
      }

      (0, _createClass3.default)(Query, [{
        key: 'render',
        value: function render() {
          var _this2 = this;

          var environment = this.context.environment;


          var variables = typeof variablesParam === 'function' ? variablesParam(this.props) : variablesParam;

          return React.createElement(_reactRelay.QueryRenderer, {
            environment: environment,
            query: queryParam,
            variables: variables,
            render: function render(_ref) {
              var props = _ref.props,
                  error = _ref.error,
                  retry = _ref.retry;

              return React.createElement(WrappedComponent, (0, _extends3.default)({}, _this2.props, props, {
                query: props,
                error: error,
                retry: retry,
                isFetching: !props && !error
              }));
            }
          });
        }
      }]);
      return Query;
    }(React.PureComponent);

    Query.contextTypes = {
      environment: PropTypes.instanceOf(_relayRuntime.Environment).isRequired
    };


    return Query;
  };
};

exports.default = query;